﻿using System;
using System.Collections.Generic;
using System.Windows;
using Infragistics.Olap;
using Infragistics.Olap.FlatData;
using System.Windows.Controls;

namespace PivotTest
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            Loaded += Page_Loaded;
        }

        private List<Population> populationList = new List<Population>();
              
        private void getPopulations()
        {
            populationList.Clear();

            // Dummy up the population figures for now

            populationList.Add(new Population { MarketName = "London", AudienceName = "Men", PopulationCount = 1040033 });
            populationList.Add(new Population { MarketName = "London", AudienceName = "Women", PopulationCount = 1640033 });
            populationList.Add(new Population { MarketName = "London", AudienceName = "Children", PopulationCount = 840033 });
            populationList.Add(new Population { MarketName = "Brighton", AudienceName = "Men", PopulationCount = 1040783 });
            populationList.Add(new Population { MarketName = "Brighton", AudienceName = "Women", PopulationCount = 16488033 });
            populationList.Add(new Population { MarketName = "Brighton", AudienceName = "Children", PopulationCount = 89533 });
        }

        private void DoPivot()
        {
            getPopulations();

            FlatDataSource flatDataSource = new FlatDataSource
            {
                ItemsSource = populationList,
                Cube = DataSourceBase.GenerateInitialCube("Population"),
                Rows = DataSourceBase.GenerateInitialItems("[MarketName]"),
                Columns = DataSourceBase.GenerateInitialItems("[AudienceName]"),
                Measures = DataSourceBase.GenerateInitialItems("PopulationCount")
            };

            pivotGrid.DataSource = flatDataSource;
        }

        void Page_Loaded(object sender, RoutedEventArgs e)
        {
            DoPivot();
        }
    }
}
